#include <iostream>

#include "Relation.hh"
#include "PhysAlgebra.hh"

/*
 * Implement your queries in this file. There is an example query given below 
 * over the test data set. Take a look at the sub directory database to see how data
 * is stored there.
 * In database you will also find the crimeInAtlanta2017 data set that contains 
 * crime records of Atlanta for the year 2017. For details on the data see:
 * https://www.kaggle.com/priscillapun/crime-in-atlanta-2017
 * All datasets are stored in the subdirectory database. See Relation.hh for details.
 *
 * To implement a query we use the classes given in Relation.hh and physAlgebra.hh.
 * The operators given in physAlgebra.hh allow us to manually build a query plan
 * and to run it.
 *
 * Note on compilation: This implementation uses rather new C++17 features.
 * More specifically, it uses the std::variant class and its features.
 * Set the -std=c++17 compiler flag to compile.
 * It might be that not all compilers have implemented all C++17 features yet.
 * compile with:
 *   g++ -std=c++17 -Wall main.cc Relation.cc -o main.out
 * or use the given makefile.
 */

int main () {
  // read relations to main memory
  Relation testRel ("test", ',');
  //relation.print(std::cout);
  Relation atlantaRel ("crimeInAtlanta2017", ',');
  //relation.print(std::cout);

  {
    std::cout << "  === Example query ===" << std::endl;
    // Exmple query: Find the names of all Persons
    // SQL:     SELECT name FROM test;

    Top                         top        (true, std::cout); 
    Projection <Top>            projection (top, {1});
    Tablescan <Projection<Top>> scan       (testRel.getData(), projection);

    scan.run();
  }
}
